﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Windows.Forms.Integration;

namespace WinFormsHostApp
{
    public partial class Form1 : Form
    {
        System.Windows.Window window;
        public Form1()
        {
            InitializeComponent();

            this.Height = 350;
            this.Width = 800;

            Button b = new Button();
            b.Text = "Open Chart on New Thread";
            b.Click += b_Click;

            b.Height = 300;
            b.Width = 700;

            this.Controls.Add(b);      
        }
        
        void b_Click(object sender, EventArgs e)
        {
            Thread thread = new Thread(() =>
            {
                try
                {
                    Program.EnsureApplicationResources();
                    System.Windows.Window w = GetWPFWindow();
                    ElementHost.EnableModelessKeyboardInterop(w);
                    w.Show();
                    w.Closed += (s, ea) => w.Dispatcher.InvokeShutdown();
                    System.Windows.Threading.Dispatcher.Run();
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.StackTrace);
                }
            });

            thread.SetApartmentState(ApartmentState.STA);
            thread.Start();
        }

        public System.Windows.Window GetWPFWindow()
        {
            return new XamDataChartToBeHosted.MainWindow();
        }
    }
}
